'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _objectStyles = require('./objectStyles');

var _objectStyles2 = _interopRequireDefault(_objectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A view for object property names.
 *
 * If the property name is enumerable (in Object.keys(object)),
 * the property name will be rendered normally.
 *
 * If the property name is not enumerable (`Object.prototype.propertyIsEnumerable()`),
 * the property name will be dimmed to show the difference.
 */
var ObjectName = function ObjectName(_ref) {
  var name = _ref.name;
  var dimmed = _ref.dimmed;
  return _react2.default.createElement(
    'span',
    { style: dimmed ? _objectStyles2.default.nameDimmed : _objectStyles2.default.name },
    name
  );
};

ObjectName.propTypes = {
  /** Property name */
  name: _react.PropTypes.string,
  /** Should property name be dimmed */
  dimmed: _react.PropTypes.bool
};

exports.default = ObjectName;