'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _unselectable = require('../styles/unselectable');

var _unselectable2 = _interopRequireDefault(_unselectable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  base: {
    lineHeight: '14px',
    cursor: 'default',

    boxSizing: 'border-box',
    listStyle: 'none',

    fontFamily: 'Menlo, monospace',
    fontSize: '11px'
  },
  // take up parent container width
  // width: '100%',
  previewContainer: {},

  placeholder: (0, _extends3.default)({
    whiteSpace: 'pre',

    fontSize: 12,
    marginRight: 3
  }, _unselectable2.default),
  arrow: (0, _extends3.default)({
    color: '#6e6e6e',
    display: 'inline-block',

    // lineHeight: '14px',
    fontSize: 12,
    marginRight: 3
  }, _unselectable2.default),

  childNodesContainer: {
    margin: 0, // reset user-agent style
    paddingLeft: 12
  }
};

var Arrow = function Arrow(_ref) {
  var expanded = _ref.expanded;
  var style = _ref.style;
  return _react2.default.createElement(
    'span',
    { style: style },
    expanded ? '▼' : '▶'
  );
};

var TreeNode = function (_Component) {
  (0, _inherits3.default)(TreeNode, _Component);

  function TreeNode() {
    (0, _classCallCheck3.default)(this, TreeNode);
    return (0, _possibleConstructorReturn3.default)(this, Object.getPrototypeOf(TreeNode).apply(this, arguments));
  }

  (0, _createClass3.default)(TreeNode, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var name = _props.name;
      var data = _props.data;
      var expanded = _props.expanded;
      var onClick = _props.onClick;
      var children = _props.children;
      var style = _props.style;
      var nodeRenderer = _props.nodeRenderer;
      var title = _props.title;
      var _props2 = this.props;
      var shouldShowArrow = _props2.shouldShowArrow;
      var shouldShowPlaceholder = _props2.shouldShowPlaceholder;


      var renderedNode = (0, _react.createElement)(nodeRenderer, this.props);

      var childNodes = expanded ? children : undefined;
      return _react2.default.createElement(
        'li',
        { 'aria-expanded': expanded, role: 'treeitem', style: styles.base, title: title },
        _react2.default.createElement(
          'div',
          { style: styles.previewContainer, onClick: onClick },
          shouldShowArrow || _react.Children.count(children) > 0 ? _react2.default.createElement(Arrow, { style: styles.arrow, expanded: expanded }) : shouldShowPlaceholder && _react2.default.createElement(
            'span',
            { style: styles.placeholder },
            ' '
          ),
          renderedNode
        ),
        _react2.default.createElement(
          'ol',
          { role: 'group', style: styles.childNodesContainer },
          childNodes
        )
      );
    }
  }]);
  return TreeNode;
}(_react.Component);

TreeNode.propTypes = {
  name: _react.PropTypes.string,
  data: _react.PropTypes.any,

  expanded: _react.PropTypes.bool,
  shouldShowArrow: _react.PropTypes.bool,
  shouldShowPlaceholder: _react.PropTypes.bool,

  nodeRenderer: _react.PropTypes.func,

  onClick: _react.PropTypes.func
};

TreeNode.defaultProps = {
  name: '',
  data: undefined,
  expanded: true,

  nodeRenderer: function nodeRenderer(_ref2) {
    var name = _ref2.name;
    var data = _ref2.data;
    var expanded = _ref2.expanded;
    return _react2.default.createElement(
      'span',
      null,
      name
    );
  },

  onClick: function onClick() {},

  shouldShowArrow: false,
  shouldShowPlaceholder: true
};

exports.default = TreeNode;